<template>
  <q-form ref="form" @submit="onSubmit" @reset="onReset">
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-select
          outlined
          clearable
          dense
          options-dense
          use-input
          emit-value
          map-options
          label="Paises *"
          :options="countryOptions"
          :rules="[val => !!val || 'Campo es requerido.']"
          @filter="filterCountry"
          v-model="draft.country"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey">
                No results
              </q-item-section>
            </q-item>
          </template>
        </q-select>
      </div>
      <div class="col">
        <q-select
          outlined
          clearable
          dense
          options-dense
          use-input
          emit-value
          map-options
          label="Marcas *"
          :options="brandOptions"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model="draft.brand"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey">
                No results
              </q-item-section>
            </q-item>
          </template>
        </q-select>
      </div>
    </div>
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-input
          outlined
          bottom-slots
          dense
          label="Nombre *"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model="draft.name"
        />
      </div>
      <div class="col">
        <div class="q-field--with-bottom">Presentación <q-btn flat color="primary" icon="fas fa-plus-circle" @click="setPresentation" /></div>
        <d-presentation v-for="(item, index) in draft.presentation" :key="index" :presentation="item" :index="index" @add="addPresentation" @destroy="destroyPresentation"></d-presentation>
      </div>
    </div>
    <div class="q-pb-lg">
      <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm" />
      <q-btn :label="submit" type="submit" color="primary" />
    </div>
  </q-form>
</template>

<script>
import { mapGetters } from 'vuex'

import dPresentation from './Presentation'

export default {
  props: ['product', 'editing'],
  components: {
    dPresentation
  },
  data () {
    return {
      draft: this.product
    }
  },
  mounted () {
    this.$store.dispatch('shared/getCountries')
    this.$store.dispatch('shared/getBrands')
  },
  watch: {
    product: function (data) {
      this.draft = JSON.parse(JSON.stringify(data))
    }
  },
  computed: {
    ...mapGetters({
      countryOptions: 'shared/countryOptions',
      brandOptions: 'shared/brandOptions'
    }),
    submit () {
      return this.editing ? 'Actualizar' : 'Guardar'
    }
  },
  methods: {
    filterCountry (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHCOUNTRIES', search)
      })
    },
    filterBrand (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHBRANDS', search)
      })
    },
    setPresentation () {
      this.draft.presentation.push('')
    },
    addPresentation ({ index, data }) {
      this.draft.presentation.splice(index, 1, data)
    },
    destroyPresentation (index) {
      this.draft.presentation.splice(index, 1)
    },
    onSubmit () {
      this.$refs.form.validate().then(success => {
        if (success) {
          this.$emit('save', this.draft)
        }
      })
    },
    onReset () {
      this.draft = JSON.parse(JSON.stringify(this.product))
    }
  }
}
</script>
